Index: pjproject/trunk/pjmedia/build/Makefile
===================================================================
--- pjproject/trunk/pjmedia/build/Makefile	(revision 627)
+++ pjproject/trunk/pjmedia/build/Makefile	(revision 628)
@@ -104,6 +104,6 @@
 		speex/quant_lsp.o speex/sb_celp.o speex/smallft.o \
 		speex/speex.o speex/speex_callbacks.o speex/speex_header.o \
-		speex/stereo.o speex/vbr.o speex/vq.o
-SPEEX_CFLAGS := -DHAVE_CONFIG=1 -I../src/pjmedia-codec
+		speex/stereo.o speex/vbr.o speex/vq.o speex/window.o
+SPEEX_CFLAGS := -DHAVE_CONFIG_H=1 -I../src/pjmedia-codec
 
 export PJMEDIA_CODEC_SRCDIR = ../src/pjmedia-codec
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/speex/_kiss_fft_guts.h
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/speex/_kiss_fft_guts.h	(revision 627)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/speex/_kiss_fft_guts.h	(revision 628)
@@ -21,5 +21,4 @@
    typedef struct { kiss_fft_scalar r; kiss_fft_scalar i; }kiss_fft_cpx; */
 #include "kiss_fft.h"
-#include <limits.h>
 
 #define MAXFACTORS 32
@@ -46,6 +45,7 @@
  * */
 #ifdef FIXED_POINT
+#include "misc.h"
 # define FRACBITS 15
-# define SAMPPROD int32_t 
+# define SAMPPROD spx_int32_t 
 #define SAMP_MAX 32767
 
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/speex/arch.h
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/speex/arch.h	(revision 627)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/speex/arch.h	(revision 628)
@@ -42,4 +42,5 @@
 #define MAX16(a,b) ((a) > (b) ? (a) : (b))   /**< Maximum 16-bit value.   */
 #define ABS32(x) ((x) < 0 ? (-(x)) : (x))    /**< Absolute 32-bit value.  */
+#define MAX32(a,b) ((a) > (b) ? (a) : (b))   /**< Maximum 32-bit value.   */
 
 #ifdef FIXED_POINT
@@ -47,11 +48,4 @@
 typedef spx_int16_t spx_word16_t;
 typedef spx_int32_t   spx_word32_t;
-#ifdef _MSC_VER
-typedef __int64      spx_word64_t;
-#elif defined NO_LONGLONG
-typedef double    spx_word64_t;
-#else
-typedef long long    spx_word64_t;
-#endif
 typedef spx_word32_t spx_mem_t;
 typedef spx_word16_t spx_coef_t;
@@ -104,5 +98,4 @@
 typedef float spx_word16_t;
 typedef float spx_word32_t;
-typedef float spx_word64_t;
 
 #define Q15ONE 1.0f
@@ -147,5 +140,4 @@
 #define ADD32(a,b) ((a)+(b))
 #define SUB32(a,b) ((a)-(b))
-#define ADD64(a,b) ((a)+(b))
 #define MULT16_16_16(a,b)     ((a)*(b))
 #define MULT16_16(a,b)     ((spx_word32_t)(a)*(spx_word32_t)(b))
@@ -162,4 +154,5 @@
 #define MAC16_16_Q11(c,a,b)     ((c)+(a)*(b))
 #define MAC16_16_Q13(c,a,b)     ((c)+(a)*(b))
+#define MAC16_16_P13(c,a,b)     ((c)+(a)*(b))
 #define MULT16_16_Q11_32(a,b)     ((a)*(b))
 #define MULT16_16_Q13(a,b)     ((a)*(b))
@@ -167,7 +160,11 @@
 #define MULT16_16_Q15(a,b)     ((a)*(b))
 #define MULT16_16_P15(a,b)     ((a)*(b))
+#define MULT16_16_P13(a,b)     ((a)*(b))
+#define MULT16_16_P14(a,b)     ((a)*(b))
 
-#define DIV32_16(a,b)     ((a)/(b))
-#define DIV32(a,b)     ((a)/(b))
+#define DIV32_16(a,b)     (((spx_word32_t)(a))/(spx_word16_t)(b))
+#define PDIV32_16(a,b)     (((spx_word32_t)(a))/(spx_word16_t)(b))
+#define DIV32(a,b)     (((spx_word32_t)(a))/(spx_word32_t)(b))
+#define PDIV32(a,b)     (((spx_word32_t)(a))/(spx_word32_t)(b))
 
 
@@ -175,5 +172,5 @@
 
 
-#ifdef CONFIG_TI_C55X
+#if defined (CONFIG_TI_C54X) || defined (CONFIG_TI_C55X)
 
 /* 2 on TI C5x DSP */
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/speex/bits.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/speex/bits.c	(revision 627)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/speex/bits.c	(revision 628)
@@ -94,26 +94,34 @@
 {
    int i;
-   if (len > bits->buf_size)
+   int nchars = len / BYTES_PER_CHAR;
+   if (nchars > bits->buf_size)
    {
       speex_warning_int("Packet is larger than allocated buffer: ", len);
       if (bits->owner)
       {
-         char *tmp = (char*)speex_realloc(bits->chars, len);
+         char *tmp = (char*)speex_realloc(bits->chars, nchars);
          if (tmp)
          {
-            bits->buf_size=len;
+            bits->buf_size=nchars;
             bits->chars=tmp;
          } else {
-            len=bits->buf_size;
+            nchars=bits->buf_size;
             speex_warning("Could not resize input buffer: truncating input");
          }
       } else {
          speex_warning("Do not own input buffer: truncating input");
-         len=bits->buf_size;
-      }
-   }
-   for (i=0;i<len;i++)
-      bits->chars[i]=chars[i];
-   bits->nbBits=len<<3;
+         nchars=bits->buf_size;
+      }
+   }
+#if (BYTES_PER_CHAR==2)
+/* Swap bytes to proper endian order (could be done externally) */
+#define HTOLS(A) ((((A) >> 8)&0xff)|(((A) & 0xff)<<8))
+#else
+#define HTOLS(A) (A)
+#endif
+   for (i=0;i<nchars;i++)
+      bits->chars[i]=HTOLS(chars[i]);
+
+   bits->nbBits=nchars<<LOG2_BITS_PER_CHAR;
    bits->charPtr=0;
    bits->bitPtr=0;
@@ -162,5 +170,5 @@
    pos=bits->nbBits>>LOG2_BITS_PER_CHAR;
    for (i=0;i<nchars;i++)
-      bits->chars[pos+i]=chars[i];
+      bits->chars[pos+i]=HTOLS(chars[i]);
    bits->nbBits+=nchars<<LOG2_BITS_PER_CHAR;
 }
@@ -183,9 +191,5 @@
    if (max_nchars > ((bits->nbBits+BITS_PER_CHAR-1)>>LOG2_BITS_PER_CHAR))
       max_nchars = ((bits->nbBits+BITS_PER_CHAR-1)>>LOG2_BITS_PER_CHAR);
-#if BYTES_PER_CHAR==1
-#define HTOLS(A) (A)
-#else
-#define HTOLS(A) ((((A) >> 8)&0xff)|(((A) & 0xff)<<8))
-#endif
+
    for (i=0;i<max_nchars;i++)
       chars[i]=HTOLS(bits->chars[i]);
@@ -200,6 +204,6 @@
       max_nchars = ((bits->nbBits)>>LOG2_BITS_PER_CHAR);
    for (i=0;i<max_nchars;i++)
-      chars[i]=bits->chars[i];
-   
+      chars[i]=HTOLS(bits->chars[i]);
+
    if (bits->bitPtr>0)
       bits->chars[0]=bits->chars[max_nchars];
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/speex/cb_search.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/speex/cb_search.c	(revision 627)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/speex/cb_search.c	(revision 628)
@@ -71,5 +71,5 @@
             resj = MAC16_16(resj,shape[k],r[j-k]);
 #ifdef FIXED_POINT
-         res16 = EXTRACT16(SHR32(resj, 11));
+         res16 = EXTRACT16(SHR32(resj, 13));
 #else
          res16 = 0.03125f*resj;
@@ -89,7 +89,6 @@
 {
    int n;
-   int q=0;
-   for (n=0;n<len;n++,q++)
-      t[n] = SUB32(t[n],MULT16_16_Q11_32(g,r[q]));
+   for (n=0;n<len;n++)
+      t[n] = SUB16(t[n],PSHR32(MULT16_16(g,r[n]),13));
 }
 #endif
@@ -98,5 +97,5 @@
 
 static void split_cb_search_shape_sign_N1(
-spx_sig_t target[],			/* target vector */
+spx_word16_t target[],			/* target vector */
 spx_coef_t ak[],			/* LPCs for this subframe */
 spx_coef_t awk1[],			/* Weighted LPCs for this subframe */
@@ -114,7 +113,4 @@
 {
    int i,j,m,q;
-#ifndef FIXED_POINT
-   int n;
-#endif
    VARDECL(spx_word16_t *resp);
 #ifdef _USE_SSE
@@ -159,5 +155,5 @@
    /* FIXME: make that adaptive? */
    for (i=0;i<nsf;i++)
-      t[i]=EXTRACT16(PSHR32(target[i],6));
+      t[i]=target[i];
 
    compute_weighted_codebook(shape_cb, r, resp, resp2, E, shape_cb_size, subvect_size, stack);
@@ -223,11 +219,8 @@
 #ifdef FIXED_POINT
          g=sign*shape_cb[rind*subvect_size+m];
+#else
+         g=sign*0.03125*shape_cb[rind*subvect_size+m];
+#endif
          target_update(t+subvect_size*(i+1), g, r+q, nsf-subvect_size*(i+1));
-#else
-         g=sign*0.03125*shape_cb[rind*subvect_size+m];
-         /*FIXME: I think that one too can be replaced by target_update */
-         for (n=subvect_size*(i+1);n<nsf;n++,q++)
-            t[n] = SUB32(t[n],g*r[q]);
-#endif
       }
    }
@@ -245,5 +238,5 @@
       syn_percep_zero(e, ak, awk1, awk2, r2, nsf,p, stack);
       for (j=0;j<nsf;j++)
-         target[j]=SUB32(target[j],r2[j]);
+         target[j]=SUB16(target[j],EXTRACT16(PSHR32(r2[j],8)));
    }
 }
@@ -252,5 +245,5 @@
 
 void split_cb_search_shape_sign(
-spx_sig_t target[],			/* target vector */
+spx_word16_t target[],			/* target vector */
 spx_coef_t ak[],			/* LPCs for this subframe */
 spx_coef_t awk1[],			/* Weighted LPCs for this subframe */
@@ -357,5 +350,5 @@
    /* FIXME: make that adaptive? */
    for (i=0;i<nsf;i++)
-      t[i]=EXTRACT16(PSHR32(target[i],6));
+      t[i]=target[i];
 
    for (j=0;j<N;j++)
@@ -445,11 +438,8 @@
 #ifdef FIXED_POINT
             g=sign*shape_cb[rind*subvect_size+m];
+#else
+            g=sign*0.03125*shape_cb[rind*subvect_size+m];
+#endif
             target_update(nt[j]+subvect_size*(i+1), g, r+q, nsf-subvect_size*(i+1));
-#else
-            g=sign*0.03125*shape_cb[rind*subvect_size+m];
-            /*FIXME: I think that one too can be replaced by target_update */
-            for (n=subvect_size*(i+1);n<nsf;n++,q++)
-               nt[j][n] = SUB32(nt[j][n],g*r[q]);
-#endif
          }
 
@@ -515,5 +505,5 @@
       syn_percep_zero(e, ak, awk1, awk2, r2, nsf,p, stack);
       for (j=0;j<nsf;j++)
-         target[j]=SUB32(target[j],r2[j]);
+         target[j]=SUB16(target[j],EXTRACT16(PSHR32(r2[j],8)));
    }
 }
@@ -578,5 +568,5 @@
 
 void noise_codebook_quant(
-spx_sig_t target[],			/* target vector */
+spx_word16_t target[],			/* target vector */
 spx_coef_t ak[],			/* LPCs for this subframe */
 spx_coef_t awk1[],			/* Weighted LPCs for this subframe */
@@ -596,5 +586,7 @@
    VARDECL(spx_sig_t *tmp);
    ALLOC(tmp, nsf, spx_sig_t);
-   residue_percep_zero(target, ak, awk1, awk2, tmp, nsf, p, stack);
+   for (i=0;i<nsf;i++)
+      tmp[i]=PSHR32(EXTEND32(target[i]),SIG_SHIFT);
+   residue_percep_zero(tmp, ak, awk1, awk2, tmp, nsf, p, stack);
 
    for (i=0;i<nsf;i++)
@@ -602,5 +594,4 @@
    for (i=0;i<nsf;i++)
       target[i]=0;
-
 }
 
@@ -614,4 +605,8 @@
 )
 {
-   speex_rand_vec(1, exc, nsf);
+   int i;
+   /* FIXME: This is bad, but I don't think the function ever gets called anyway */
+   spx_int32_t seed = 0;
+   for (i=0;i<nsf;i++)
+      exc[i]=SHL32(EXTEND32(speex_rand(1, &seed)),SIG_SHIFT);
 }
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/speex/cb_search.h
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/speex/cb_search.h	(revision 627)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/speex/cb_search.h	(revision 628)
@@ -50,5 +50,5 @@
 
 void split_cb_search_shape_sign(
-spx_sig_t target[],             /* target vector */
+spx_word16_t target[],             /* target vector */
 spx_coef_t ak[],                /* LPCs for this subframe */
 spx_coef_t awk1[],              /* Weighted LPCs for this subframe */
@@ -75,5 +75,5 @@
 
 void noise_codebook_quant(
-spx_sig_t target[],             /* target vector */
+spx_word16_t target[],             /* target vector */
 spx_coef_t ak[],                /* LPCs for this subframe */
 spx_coef_t awk1[],              /* Weighted LPCs for this subframe */
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/speex/cb_search_bfin.h
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/speex/cb_search_bfin.h	(revision 627)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/speex/cb_search_bfin.h	(revision 628)
@@ -62,5 +62,5 @@
             "LOOP_END inner%=;\n\t"
             "R0 = A0;\n\t"
-            "R0 >>>= 11;\n\t"
+            "R0 >>>= 13;\n\t"
             "A1 += R0.L*R0.L (IS);\n\t"
             "W[P3++] = R0;\n\t"
@@ -73,5 +73,6 @@
          :
       : "m" (subvect_size), "m" (shape_cb), "m" (r), "m" (resp), "m" (E)
-      : "A0", "P0", "P1", "P2", "P3", "P4", "R0", "R1", "R2", "I0", "I1", "L0", "L1", "A0", "A1", "memory"
+      : "A0", "P0", "P1", "P2", "P3", "P4", "R0", "R1", "R2", "I0", "I1", "L0", 
+        "L1", "A0", "A1", "memory", "LC0", "LC1"
       );
       shape_cb += subvect_size;
@@ -84,4 +85,6 @@
 static inline void target_update(spx_word16_t *t, spx_word16_t g, spx_word16_t *r, int len)
 {
+   if (!len)
+      return;
    __asm__ __volatile__
          (
@@ -90,9 +93,11 @@
          "L0 = 0;\n\t"
          "L1 = 0;\n\t"
+         "R2 = 4096;\n\t"
          "LOOP tupdate%= LC0 = %3;\n\t"
          "LOOP_BEGIN tupdate%=;\n\t"
             "R0.L = W[I0] || R1.L = W[I1++];\n\t"
             "R1 = (A1 = R1.L*%2.L) (IS);\n\t"
-            "R1 >>>= 11;\n\t"
+            "R1 = R1 + R2;\n\t"
+            "R1 >>>= 13;\n\t"
             "R0.L = R0.L - R1.L;\n\t"
             "W[I0++] = R0.L;\n\t"
@@ -100,6 +105,5 @@
    :
    : "a" (t), "a" (r), "d" (g), "a" (len)
-   : "R0", "R1", "A1", "I0", "I1", "L0", "L1"
+   : "R0", "R1", "R2", "A1", "I0", "I1", "L0", "L1"
          );
 }
-
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/speex/config.h
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/speex/config.h	(revision 627)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/speex/config.h	(revision 628)
@@ -1,4 +1,8 @@
 
-#include <pj/config.h>
+/* Check if we need to use the fixed point version */
+#if !defined(PJ_HAS_FLOATING_POINT) || PJ_HAS_FLOATING_POINT==0
+#   define FIXED_POINT
+#endif
+
 
 #define inline __inline
@@ -6,8 +10,4 @@
 
 #include "misc.h"
-
-#if !defined(PJ_HAS_FLOATING_POINT) || PJ_HAS_FLOATING_POINT==0
-#   define FIXED_POINT
-#endif
 
 #ifdef _MSC_VER
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/speex/fftwrap.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/speex/fftwrap.c	(revision 627)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/speex/fftwrap.c	(revision 628)
@@ -43,4 +43,5 @@
 #include "misc.h"
 
+#define MAX_FFT_SIZE 2048
 
 #ifdef FIXED_POINT
@@ -226,7 +227,6 @@
 
 
-int fixed_point = 1;
 #ifdef FIXED_POINT
-#include "smallft.h"
+/*#include "smallft.h"*/
 
 
@@ -240,6 +240,11 @@
 #else
 #endif
+#ifdef VAR_ARRAYS
    spx_word16_t _in[N];
    spx_word16_t _out[N];
+#else
+   spx_word16_t _in[MAX_FFT_SIZE];
+   spx_word16_t _out[MAX_FFT_SIZE];
+#endif
    for (i=0;i<N;i++)
       _in[i] = (int)floor(.5+in[i]);
@@ -247,4 +252,5 @@
    for (i=0;i<N;i++)
       out[i] = _out[i];
+#if 0
    if (!fixed_point)
    {
@@ -258,4 +264,5 @@
       spx_drft_clear(&t);
    }
+#endif
 }
 
@@ -269,6 +276,11 @@
 #else
 #endif
+#ifdef VAR_ARRAYS
    spx_word16_t _in[N];
    spx_word16_t _out[N];
+#else
+   spx_word16_t _in[MAX_FFT_SIZE];
+   spx_word16_t _out[MAX_FFT_SIZE];
+#endif
    for (i=0;i<N;i++)
       _in[i] = (int)floor(.5+in[i]);
@@ -276,4 +288,5 @@
    for (i=0;i<N;i++)
       out[i] = _out[i];
+#if 0
    if (!fixed_point)
    {
@@ -286,4 +299,5 @@
       spx_drft_clear(&t);
    }
+#endif
 }
 
